; Get the command-line arguments sent by far
; - the first argument is the hwnd of the last active window
; - concatenate the rest to build up the path to the folder
Loop, %0%
{
	If (A_Index = 1)
		f_window_id := %A_Index%
	Else
		f_path .= %A_Index% " "
}

; Get necessary information about the last active window
StringTrimRight, f_path, f_path, 1
WinGetClass, f_class, ahk_id %f_window_id%
StringLeft, f_class_short, f_class, 8	; this is used to detect Office 2007 save file dialogs

if f_class in #32770,ExploreWClass,CabinetWClass  ; Dialog or Explorer.
{
    ControlGetPos, f_Edit1Pos,,,, Edit1, ahk_id %f_window_id%
    ControlGetPos, f_TBW32Pos,,,, ToolbarWindow322, ahk_id %f_window_id%
}

; most of the code below lifted straight from FavoriteFolders.ahk, by Savage of the AHK forums
; (with the exception of the Vista/7 explorer fix)
; http://www.autohotkey.com/docs/scripts/FavoriteFolders.htm
if f_class = #32770    ; It's a dialog.
{
	if f_Edit1Pos <>   ; And it has an Edit1 control.
	{
		; Activate the window so that if the user is middle-clicking
		; outside the dialog, subsequent clicks will also work:
		WinActivate ahk_id %f_window_id%
		; Retrieve any filename that might already be in the field so
		; that it can be restored after the switch to the new folder:
		ControlGetText, f_text, Edit1, ahk_id %f_window_id%
		ControlSetText, Edit1, %f_path%, ahk_id %f_window_id%
		ControlSend, Edit1, {Enter}, ahk_id %f_window_id%
		Sleep, 100  ; It needs extra time on some dialogs or in some cases.
		ControlSetText, Edit1, %f_text%, ahk_id %f_window_id%
		return
	}
	; else fall through to the bottom of the subroutine to take standard action.
}
else if f_class_short = bosa_sdm	; Office 2007 dialogs
{
	WinActivate ahk_id %f_window_id%
	ControlGetText, f_text, RichEdit20W2, ahk_id %f_window_id%
	ControlSetText, RichEdit20W2, %f_path%, ahk_id %f_window_id%
	ControlSend, RichEdit20W2, {Enter}, ahk_id %f_window_id%
	Sleep, 100  ; It needs extra time on some dialogs or in some cases.
	ControlSetText, RichEdit20W2, %f_text%, ahk_id %f_window_id%
	return
}
else if f_class in dopus.lister	; Directory Opus
{
	ControlSetText, Edit2, %f_path%, ahk_id %f_window_id%
	ControlSend, Edit2, {Right}{Enter}, ahk_id %f_window_id%
	return
}
else if f_class in ExploreWClass,CabinetWClass  ; In Explorer, switch folders.
{
	if f_Edit1Pos <>   ; And it has an Edit1 control.
	{
		ControlSetText, Edit1, %f_path%, ahk_id %f_window_id%
		; Tekl reported the following: "If I want to change to Folder L:\folder
		; then the addressbar shows http://www.L:\folder.com. To solve this,
		; I added a {right} before {Enter}":
		ControlSend, Edit1, {Right}{Enter}, ahk_id %f_window_id%
		return
	}
	; fix for Vista/7
	if f_TBW32Pos <>
	{
		ControlClick, ToolbarWindow322, ahk_id %f_window_id%
		; Tekl reported the following: "If I want to change to Folder L:\folder
		; then the addressbar shows http://www.L:\folder.com. To solve this,
		; I added a {right} before {Enter}":
		ControlSend, Edit1, {Right}{Enter}, ahk_id %f_window_id%
		return
	}
	; else fall through to the bottom of the subroutine to take standard action.
}
else if f_class = ConsoleWindowClass ; In a console window, CD to that directory
{
	WinActivate, ahk_id %f_window_id% ; Because sometimes the mclick deactivates it.
	SetKeyDelay, 0  ; This will be in effect only for the duration of this thread.
	IfInString, f_path, :  ; It contains a drive letter
	{
		StringLeft, f_path_drive, f_path, 1
		Send %f_path_drive%:{enter}
	}
	Send, cd %f_path%{Enter}
	return
}
Run, Explorer %f_path%  ; Might work on more systems without double quotes.